diff -burNi '--exclude=.git' '--exclude=tests' '--exclude=*.md' '--exclude=*.bat' '--exclude=deploy' '--exclude=.travis.yml' ../etherpad-lite/ecosystem.config.js ./ecosystem.config.js
--- ../etherpad-lite/ecosystem.config.js	1970-01-01 01:00:00.000000000 +0100
+++ ./ecosystem.config.js	2020-07-19 01:36:49.157350578 +0200
@@ -0,0 +1,17 @@
+module.exports = {
+	apps : [
+		{
+		    name: 'front',
+		    script: 'src/node/server.js',
+		    instances: 1,
+		    env_k8s: {
+			    'NODE_ENV': 'production',
+			    'PORT': '8080'
+			},
+		    env_production: {
+			    'NODE_ENV': 'production',
+			    'PORT': '8080'
+			}
+		}
+	    ]
+    };
diff -burNi '--exclude=.git' '--exclude=tests' '--exclude=*.md' '--exclude=*.bat' '--exclude=deploy' '--exclude=.travis.yml' ../etherpad-lite/.gitignore ./.gitignore
--- ../etherpad-lite/.gitignore	2020-10-05 21:40:08.123529772 +0200
+++ ./.gitignore	2020-10-05 23:53:13.182964015 +0200
@@ -1,3 +1,4 @@
+/Makefile.cust
 node_modules
 /settings.json
 !settings.json.template
@@ -9,7 +10,6 @@
 var/dirty.db
 bin/convertSettings.json
 *~
-*.patch
 src/static/js/jquery.js
 npm-debug.log
 *.DS_Store
@@ -22,3 +22,4 @@
 .nyc_output
 ./package-lock.json
 .idea
+*.[0-9]
diff -burNi '--exclude=.git' '--exclude=tests' '--exclude=*.md' '--exclude=*.bat' '--exclude=deploy' '--exclude=.travis.yml' ../etherpad-lite/settings.json ./settings.json
--- ../etherpad-lite/settings.json	1970-01-01 01:00:00.000000000 +0100
+++ ./settings.json	2020-10-06 00:00:24.958067582 +0200
@@ -0,0 +1,84 @@
+{
+  "title": "OpsPad",
+  "favicon": "favicon.ico",
+  "skinName": "colibris",
+  "skinVariants": "super-light-toolbar super-light-editor light-background",
+  "ip": "0.0.0.0",
+  "port" : 8080,
+  "showSettingsInAdminPage" : true,
+  "dbType" : "dirty",
+  "dbSettings" : { "filename" : "var/dirty.db" },
+  "defaultPadText" : "Welcome to OpsPad!\n\nThis pad text is synchronized as you type, so that everyone viewing this page sees the same text. This allows you to collaborate seamlessly on documents!\n",
+  "padOptions": {
+    "noColors": false,
+    "showControls": true,
+    "showChat": true,
+    "showLineNumbers": true,
+    "useMonospaceFont": false,
+    "userName": false,
+    "userColor": false,
+    "rtl": false,
+    "alwaysShowChat": false,
+    "chatAndUsers": false,
+    "lang": "en-gb"
+  },
+  "padShortcutEnabled" : {
+    "altF9"     : true,
+    "altC"      : true,
+    "cmdShift2" : true,
+    "delete"    : true,
+    "return"    : true,
+    "esc"       : true,
+    "cmdS"      : true,
+    "tab"       : true,
+    "cmdZ"      : true,
+    "cmdY"      : true,
+    "cmdI"      : true,
+    "cmdB"      : true,
+    "cmdU"      : true,
+    "cmd5"      : true,
+    "cmdShiftL" : true,
+    "cmdShiftN" : true,
+    "cmdShift1" : true,
+    "cmdShiftC" : true,
+    "cmdH"      : true,
+    "ctrlHome"  : true,
+    "pageUp"    : true,
+    "pageDown"  : true
+  },
+  "suppressErrorsInPadText" : false,
+  "requireSession": false,
+  "editOnly" : false,
+  "sessionNoPassword" : false,
+  "minify" : true,
+  "maxAge" : 21600,
+  "abiword" : null,
+  "soffice" : null,
+  "tidyHtml" : null,
+  "allowUnknownFileEnds" : true,
+  "requireAuthentication": true,
+  "requireAuthorization": true,
+  "trustProxy" : false,
+  "disableIPlogging" : false,
+  "automaticReconnectionTimeout" : 0,
+  "scrollWhenFocusLineIsOutOfViewport": {
+    "percentage": {
+      "editionAboveViewport": 0,
+      "editionBelowViewport": 0
+    },
+    "duration": 0,
+    "scrollWhenCaretIsInTheLastLineOfViewport": false,
+    "percentageToScrollWhenUserPressesArrowUp": 0
+  },
+  "socketTransportProtocols" : ["xhr-polling", "jsonp-polling", "htmlfile"],
+  "loadTest": false,
+  "importExportRateLimiting": {
+    "windowMs": 90000,
+    "max": 10
+  },
+  "importMaxFileSize": 52428800,
+  "allowAnyoneToImport": false, 
+  "exposeVersion": false,
+  "loglevel": "INFO",
+  "logconfig" : { "appenders": [ { "type": "console" } ] }
+}
diff -burNi '--exclude=.git' '--exclude=tests' '--exclude=*.md' '--exclude=*.bat' '--exclude=deploy' '--exclude=.travis.yml' ../etherpad-lite/src/node/hooks/express/webaccess.js ./src/node/hooks/express/webaccess.js
--- ../etherpad-lite/src/node/hooks/express/webaccess.js	2020-10-05 23:13:20.720523259 +0200
+++ ./src/node/hooks/express/webaccess.js	2020-10-05 23:29:35.255280696 +0200
@@ -32,7 +32,7 @@
   // settings.requireAuthorization is true).
   const authorize = (fail) => {
     // Do not require auth for static paths and the API...this could be a bit brittle
-    if (req.path.match(/^\/(static|javascripts|pluginfw|api)/)) return next();
+    if (req.path.match(/^\/(static|javascripts|pluginfw|api|metrics)/)) return next();
 
     const grant = (level) => {
       level = exports.normalizeAuthzLevel(level);
@@ -91,8 +91,21 @@
   step2Authenticate = () => {
     if (settings.users == null) settings.users = {};
     const ctx = {req, res, users: settings.users, next};
-    // If the HTTP basic auth header is present, extract the username and password so it can be
-    // given to authn plugins.
+// If LemonLDAP-NG integration is configured and user is authenticated, extract the username
+// from headers
+    if (req.headers['Lm-Remote-User'] !== undefined
+        && process.env.LEMON_PORTAL !== undefined) {
+      settings.users[req.headers['Lm-Remote-User']].username = req.headers['Lm-Remote-User'];
+      req.session.user = settings.users[req.headers['Lm-Remote-User']];
+      step3Authorize();
+    } else if (process.env.LEMON_PORTAL !== undefined) {
+// LemonLDAP-NG integration is configured, yet user is not authenticated
+// redirect client to portal
+      res.redirect(process.env.LEMON_PORTAL);
+      return;
+    } else {
+// If the HTTP basic auth header is present, extract the username and password so it can be
+// given to authn plugins.
     const httpBasicAuth =
         req.headers.authorization && req.headers.authorization.search('Basic ') === 0;
     if (httpBasicAuth) {
@@ -124,6 +137,7 @@
       }
       step3Authorize();
     }));
+    }
   };
 
   step3Authorize = () => authorize(failure);
diff -burNi '--exclude=.git' '--exclude=tests' '--exclude=*.md' '--exclude=*.bat' '--exclude=deploy' '--exclude=.travis.yml' ../etherpad-lite/src/node/hooks/express.js ./src/node/hooks/express.js
--- ../etherpad-lite/src/node/hooks/express.js	2020-10-05 23:13:20.720523259 +0200
+++ ./src/node/hooks/express.js	2020-10-06 00:03:18.307355315 +0200
@@ -1,3 +1,4 @@
+var apiMetrics = require('prometheus-api-metrics');
 var hooks = require("ep_etherpad-lite/static/js/pluginfw/hooks");
 var express = require('express');
 var settings = require('../utils/Settings');
@@ -6,9 +7,15 @@
 var npm = require("npm/lib/npm.js");
 var  _ = require("underscore");
 
+var handler = false;
 var server;
 var serverName;
 
+if (process.env.LEMON_PORTAL !== undefined) {
+  try { handler = require('lemonldap-ng-handler'); }
+  catch(e) { handler = require('node-lemonldap-ng-handler'); }
+}
+
 exports.createServer = function () {
   console.log("Report bugs at https://github.com/ether/etherpad-lite/issues")
 
@@ -45,6 +52,9 @@
   }
 
   var app = express(); // New syntax for express v3
+  if (handler !== false) {
+    handler.init({ configStorage: { confFile: `./lemonldap-ng.ini` } });
+  }
 
   if (settings.ssl) {
     console.log("SSL -- enabled");
@@ -70,6 +80,9 @@
     var http = require('http');
     server = http.createServer(app);
   }
+  if (handler !== false) {
+    app.use(handler.run);
+  }
 
   app.use(function(req, res, next) {
     // res.header("X-Frame-Options", "deny"); // breaks embedded pads
@@ -109,6 +122,7 @@
     app.enable('trust proxy');
   }
 
+  app.use(apiMetrics());
   hooks.callAll("expressConfigure", {"app": app});
   hooks.callAll("expressCreateServer", {"app": app, "server": server});
 
diff -burNi '--exclude=.git' '--exclude=tests' '--exclude=*.md' '--exclude=*.bat' '--exclude=deploy' '--exclude=.travis.yml' ../etherpad-lite/src/package.json ./src/package.json
--- ../etherpad-lite/src/package.json	2020-10-05 23:13:20.724523311 +0200
+++ ./src/package.json	2020-10-05 23:46:54.028475579 +0200
@@ -39,7 +39,7 @@
     "ejs": "2.6.1",
     "etherpad-require-kernel": "1.0.9",
     "etherpad-yajsml": "0.0.2",
-    "express": "4.17.1",
+    "express": "^4.17.1",
     "express-rate-limit": "5.1.1",
     "express-session": "1.17.1",
     "find-root": "1.1.0",
@@ -48,12 +48,15 @@
     "http-errors": "1.7.3",
     "jsonminify": "0.4.1",
     "languages4translatewiki": "0.1.3",
+    "lemonldap-ng-handler": "^0.5.4",
     "lodash.clonedeep": "4.5.0",
     "log4js": "0.6.35",
     "measured-core": "1.11.2",
     "nodeify": "1.0.1",
     "npm": "6.14.5",
     "openapi-backend": "2.4.1",
+    "prom-client": "^12.0.0",
+    "prometheus-api-metrics": "^3.1.0",
     "rate-limiter-flexible": "^2.1.4",
     "rehype": "^10.0.0",
     "rehype-format": "^3.0.1",
@@ -92,8 +95,9 @@
     "url": "https://github.com/ether/etherpad-lite.git"
   },
   "scripts": {
-    "test": "nyc wtfnode node_modules/.bin/_mocha --timeout 5000 --recursive ../tests/backend/specs ../node_modules/ep_*/static/tests/backend/specs",
-    "test-container": "nyc mocha --timeout 5000 ../tests/container/specs/api"
+    "run": "make run",
+    "start": "make start",
+    "test": "make test"
   },
   "version": "1.8.6",
   "license": "Apache-2.0"
